import { instance } from './instance';
class EventAggregator {
    constructor() {
        this.channels = {};
    }
    publish(channel, ...args) {
        Promise.resolve().then(() => {
            if (Array.isArray(this.channels[channel])) {
                for (let i = 0, len = this.channels[channel].length; i < len; i++) {
                    this.channels[channel][i].func.apply(this, args);
                }
            }
            else {
            }
        });
    }
    unSubscribe(channel, ctx) {
        if (Array.isArray(this.channels[channel])) {
            for (let i = 0, len = this.channels[channel].length; i < len; i++) {
                if (this.channels[channel][i].ctx === ctx) {
                    this.channels[channel].splice(i, 1);
                }
            }
        }
        else {
        }
    }
    subscribe(channel, ctx, func) {
        if (!Array.isArray(this.channels[channel])) {
            this.channels[channel] = [];
        }
        this.channels[channel].push({ ctx: ctx, func: func });
    }
}
export function publish(channel, ...args) {
    instance(EventAggregator).publish(channel, ...args);
}
export function unSubscribe(channel, ctx) {
    instance(EventAggregator).unSubscribe(channel, ctx);
}
export function subscribe(channel, ctx, func) {
    instance(EventAggregator).subscribe(channel, ctx, func);
}
//# sourceMappingURL=eventAggregator.js.map