import { html } from 'lit-html';
import { customElement, property, attribute } from 'lit-html-utils';

@customElement('app-component')
export default class extends HTMLElement {
    @property() public coolAttribute: string = 'Cool'; //coolAttribute
    @attribute() public someCoolAttribute: string = 'SomeCool'; //some-cool-attibute
    cool: string;

    valuesChanged(type: 'property' | 'attribute', name: string, oldValue: string, newValue: string) {
        console.log('valuesChanged:', type, name, oldValue, newValue);
    }

    connectedCallback() {
        setTimeout(() => {
            this.cool = 'test';
            this.render();
        }, 3000);
    }

    public render() {
        return html`
            <home-component awsome-man=${this.cool}></home-component>
        `;
    }
}
