import { html } from 'lit-html';
import { customElement, attribute, property } from 'lit-html-utils';


@customElement('home-component')
export default class extends HTMLElement {
    @attribute() awsomeMan: string; // awsome-man attribute on html element
    @property() someValue: string; // someValue on html element class

    // common callback for changes
    valuesChanged(type: 'attribute' | 'property', name: string, oldValue: string, newValue: string) {
        console.log('valuesChanged:', type, name, oldValue, newValue);
        // I do not need to call render, this is done automatically in microtask
    }

    public render() {
        return html`
            ${this.awsomeMan} cool
        `;
    }
}



